# PACE 2023 solver: METATWW
The topic of the PACE (Parameterized Algorithms and Computational Experiments) 2023 challenge (https://pacechallenge.org/2023/) is twinwidth (https://en.wikipedia.org/wiki/Twin-width). In the heuristic track of PACE 2023 the aim is to find contraction sequences of small width. Our solver uses a two-phase approach. In phase one it finds an initial contraction sequence by contracting pairs of vertices where the size of the symmetric difference between their neighbourhoods is small. In phase two we iteratively move contractions around within specific intervals of the contraction sequence in order to reduce the width of the sequence.

## Building
The solver uses C++17. It has no other dependencies.
To build, run the following bash script.
```bash
./compile metatww
```
This produces the executable `build/metatww`.

## Running
Running the following command runs the solver on a graph in `input.gr` and writes the contraction sequence to `output.tww`.
```
./build/metatww < input.gr > output.tww
```
Both files are text-files and the formats are specified at https://pacechallenge.org/2023/io/.
